"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCConfiguration subclass:#PPCUniversalConfiguration
	instanceVariableNames:'clazz'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Core'
!

!PPCUniversalConfiguration methodsFor:'compiling'!

buildClass
    |  builder |
    self assert: (clazz isKindOf: PPCClass).
    
    builder := PPCClassBuilder new.
    
    builder compiledClassName: options parserName.
    builder compiledSuperclass: PPCompiledParser.
    builder methodDictionary: clazz methodDictionary.
    builder constants: clazz constants.

    ^ builder compileClass.	
!

initialize
    super initialize.

    clazz := PPCClass new.
!

invokePhases
    self toPPCIr.
    self createTokens.
    self cacheFirstFollow.
    self specialize.
    self createRecognizingComponents.
    self specialize.
    self inline.
    self merge.
    self check.	
    self generate.
! !

!PPCUniversalConfiguration methodsFor:'hooks'!

codeGenerator
    ^ PPCUniversalCodeGenerator new
        options: options
! !

!PPCUniversalConfiguration methodsFor:'phases'!

generate
    | rootMethod compiledParser |
    options generate ifFalse: [ ^ self ].
    
    rootMethod := self codeGenerator
        options: options;
        clazz: clazz;
        visit: ir.
    
    compiledParser := self buildClass.
    compiledParser startSymbol: rootMethod methodName.
    compiledParser := compiledParser new.
    
    ir := compiledParser.
! !

